#!F:/wamp/bin/perl/bin/perl.exe

#----------------------------------#
#	  author : Thomas Durif		   #
#----------------------------------#

use strict;
use warnings;
use CGI::Carp qw (fatalsToBrowser);
use CGI;
use XML::LibXML;
use Data::Dumper;
use HTML::Entities;
my $buffer =  new CGI ;
print "Content-type: text/html\n\n";

#----------------------------------#
#---------Initialisations----------#
#----------------------------------#
my $xml_in = 'xml.xml';
my $xml_out = $xml_in;
my $html_url = "./rendered/index.html";
my $css_url = "./rendered/style.css";
my $html_file;
my $css_file;
my $xml_file;
my $id;

my $doc;
my $root;
my $parser;
	
#----------------------------------#
#------Dtection de l'action-------#
#----------------------------------#
my $action = $buffer->param('action');

if ($action eq "init"){
# Commande de rendu de la page construite
	Init();
}

LoadXml();

if ($action eq "add"){
# Ajout d'un noeud
	$id = $buffer->param('id');
	my $parent = $buffer->param('parent');
	my $type = $buffer->param('type');
	AddNode($id, $parent, $type);
}

if ($action eq "edit_style"){
# dition du style
	$id = $buffer->param('id');
	my $data = $buffer->param('style');
	EditStyles($id, $data);
}

if ($action eq "edit_prop"){
# dition des proprits
	$id = $buffer->param('id');
	my $data = $buffer->param('prop');
	EditProperties($id, $data);
}

if ($action eq "edit_text"){
# dition du texte
	$id = $buffer->param('id');
	my $text = $buffer->param('text');
	EditText($id, $text);
}

if ($action eq "del"){
# Suppression d'un noeud
	my $id = $buffer->param('id');
	DeleteNode($id);
}

if ($action eq "render"){
# Commande de rendu de la page construite
	Render();
	RenderCss();
}

#----------------------------------#
#-------------Functions------------#
#----------------------------------#
sub LoadXml{
	$parser = XML::LibXML->new();
	$doc = $parser->parse_file($xml_in) || die ("Le fichier ".$xml_in."n'est pas un xml conforme");
	$root = $doc->getDocumentElement();
}

sub SaveXml{
	my $doc = XML::LibXML::Document->new('1.0',"iso-8859-1");
	$doc->setDocumentElement($root);
	$doc->toFile($xml_out, 1);
}

sub Init(){
	unlink($xml_out);
	open($xml_file, ">".$xml_out) || die ("Erreur d'ouverture de ".$xml_out) ;
	print {$xml_file} '<?xml version="1.0" encoding="iso-8859-1"?><projet><nodes></nodes></projet>';
	close($xml_file);
}

sub PrintChildsNodes{
# $_[0] : xml node object
	my $node = $_[0];
	my $tab = $_[1]+1;

	my @nodes = $node->findnodes('node');
	foreach my $child (@nodes){		
		print {$html_file} GetTabs($tab).'<'.$child->getAttribute('type').PrintNodeProperties($child).' id="'.$child->getAttribute('id').'">'."\n";
		PrintTextNode($child, $tab);
		PrintChildsNodes($child, $tab);
		print {$html_file} GetTabs($tab)."</".$child->getAttribute('type').">\n";
	}
}

sub PrintNodeProperties{
# $_[0] : xml node object
	my $r = "";
	my $node = $_[0];
	
	if ($node->findnodes('properties')){
		my @properties = $node->findnodes('properties')->[0]->findnodes('property');
		foreach my $property (@properties){
			if ($property->getAttribute('name') ne ""){
				$r = $r." ".$property->getAttribute('name').'="'.$property->getAttribute('value').'"';
			}
		}
	}
	return $r;
}

sub PrintTextNode{
# $_[0] : xml node object
# $_[1] : tabs
	my $node = $_[0];
	my $tab = $_[1]+1;
	if ($node->findnodes('text')){
		print {$html_file} GetTabs($tab).$node->findnodes('text')->[0]->getFirstChild->getData."\n";
	}
	
	return "";
}

sub Render{
	my $node = $root->getElementsByTagName("nodes")->[0];
	unlink($html_url);
	open($html_file, ">".$html_url) || die ("Erreur d'ouverture de ".$html_url) ;
	print {$html_file} '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">'."\n";
	print {$html_file} '<!--lastbuild:'.time().'-->'."\n";	
 	PrintChildsNodes($node, -1);

	close($html_file);
}

sub RenderCss{
	my @nodes = $root->getElementsByTagName("node");
	unlink($css_url);
	open($css_file, ">".$css_url) || die ("Erreur d'ouverture de ".$html_url) ;
	print {$css_file} '/*lastbuild:'.time().'*/'."\n";	
 	
	foreach my $child (@nodes){		
		print {$css_file} '#'.$child->getAttribute('id')."{\n";
		
		if ($child->findnodes("styles")){
			my $styles = $child->findnodes("styles")->[0];
			foreach my $style ($styles->findnodes("style")){		
				print {$css_file} ''.$style->getAttribute('name').":".$style->getAttribute('value').";\n";
			}
		}
		
		print {$css_file} "}\n\n";
	}	
	
	close($css_file);
}

sub DeleteNode{
# $_[0] : id of seached node
	my $id = $_[0];
	
	my $searched_node = GetNode($id);
	$searched_node->parentNode->removeChild($searched_node);
}

sub AddNode{
# $_[0] : id of new node
# $_[1] : id of parent
# $_[2] : type
	my $parent_node = GetNode($_[1]);
	
	my $new_node = $doc->createElement("node");
	$new_node->setAttribute('id', $_[0]);
	$new_node->setAttribute('type', $_[2]);
	$parent_node->appendChild($new_node);
}

sub ParseMyData{
# $_[0] : string of values : aaabbb@cccddd@eeefff@
	my @tab;
	my $i=0;
	foreach my $prop (split(/@/, $_[0])){
		my @line = split(/\/, $prop);	
		
		$tab[$i][0] = substr($line[0], 0, length($line[0])-1);
		$tab[$i][1] = $line[1];
		
		$i++;
	}
	
	return @tab;
}

sub EditText{
# $_[0] : id of the node
# $_[1] : data
	my $id = $_[0];
	my $data = $_[1];
	my $searched_node = GetNode($id);
	
	if ($searched_node->findnodes("text")){
		$searched_node->removeChild($searched_node->findnodes("text")->[0]);
	}
	
	my $new_text = $doc->createElement("text");
	$searched_node->appendChild($new_text);
	$new_text->appendChild($doc->createCDATASection($data));
}

sub EditProperties{
# $_[0] : id of the node
# $_[1] : data
	my $id = $_[0];
	my $data = $_[1];
	my $searched_node = GetNode($id);
	
	if ($searched_node->findnodes("properties")){
		$searched_node->removeChild($searched_node->findnodes("properties")->[0]);
	}
	
	my $new_prop = $doc->createElement("properties");
	$searched_node->appendChild($new_prop);
	
	my @tab = ParseMyData($data);
	my $size = scalar @tab;
	for (my $i=0; $i<$size; $i++){
		my $s = $doc->createElement("property");
		$new_prop->appendChild($s);
		$s->setAttribute('name', $tab[$i][0]);
		$s->setAttribute('value', $tab[$i][1]);
	}
}

sub EditStyles{
# $_[0] : id of the node
# $_[1] : data
	my $id = $_[0];
	my $data = $_[1];
	my $searched_node = GetNode($id);
	
	if ($searched_node->findnodes("styles")){
		$searched_node->removeChild($searched_node->findnodes("styles")->[0]);
	}
	
	my $new_prop = $doc->createElement("styles");
	$searched_node->appendChild($new_prop);
	
	my @tab = ParseMyData($data);
	my $size = scalar @tab;
	for (my $i=0; $i<$size; $i++){
		my $s = $doc->createElement("style");
		$new_prop->appendChild($s);
		$s->setAttribute('name', $tab[$i][0]);
		$s->setAttribute('value', $tab[$i][1]);
	}
}

sub GetTabs{
# $_[0] : tab count
	my $r = "";
	for (my $i=0; $i<$_[0]; $i++){
		$r = $r."\t";
	}
	return $r;
}

sub GetNode{
# $_[0] : id of the searched node
	my $id = $_[0];
	
	if ($id eq "node-0"){
		return $root->getElementsByTagName("nodes")->[0];
	}
	
	my $searched_node;
	my @nodes = $root->getElementsByTagName("node");
	foreach my $node (@nodes){		
		if ($node->getAttribute('id') eq $id){
			$searched_node = $node;
			last;
		}
	}	
	return $searched_node;
}

SaveXml();
print "ok";